config/routes.rb
Rails.application.routes.draw do
  root 'learning_resources#index'  
  resources :quiz_transactions
  resources :learning_resource_transactions
  resources :quiz_questions
  resources :learning_resources
  devise_for :users

  resources :quizzes do
    resources :questions
  end

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  
  # Defines the root path route ("/")
  # root "posts#index"
end

app/controllers/quiz_transactions_controller.rb
class QuizTransactionsController < ApplicationController
  before_action :set_quiz_transaction, only: %i[ show edit update destroy ]

  # GET /quiz_transactions or /quiz_transactions.json
  def index
    @quiz_transactions = QuizTransaction.all
  end

  # GET /quiz_transactions/1 or /quiz_transactions/1.json
  def show
  end

  # GET /quiz_transactions/new
  def new
    @quiz_transaction = QuizTransaction.new
  end

  # GET /quiz_transactions/1/edit
  def edit
  end

  # POST /quiz_transactions or /quiz_transactions.json
  def create
    @quiz_transaction = QuizTransaction.new(quiz_transaction_params)

    respond_to do |format|
      if @quiz_transaction.save
        format.html { redirect_to quiz_transaction_url(@quiz_transaction), notice: "Quiz transaction was successfully created." }
        format.json { render :show, status: :created, location: @quiz_transaction }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz_transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quiz_transactions/1 or /quiz_transactions/1.json
  def update
    respond_to do |format|
      if @quiz_transaction.update(quiz_transaction_params)
        format.html { redirect_to quiz_transaction_url(@quiz_transaction), notice: "Quiz transaction was successfully updated." }
        format.json { render :show, status: :ok, location: @quiz_transaction }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz_transaction.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quiz_transactions/1 or /quiz_transactions/1.json
  def destroy
    @quiz_transaction.destroy!

    respond_to do |format|
      format.html { redirect_to quiz_transactions_url, notice: "Quiz transaction was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quiz_transaction
      @quiz_transaction = QuizTransaction.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def quiz_transaction_params
      params.fetch(:quiz_transaction, {})
    end
end

app/helpers/quiz_transactions_helper.rb
module QuizTransactionsHelper
end

app/views/quiz_transactions/_form.html.erb
<%= form_with(model: quiz_transaction) do |form| %>
  <% if quiz_transaction.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(quiz_transaction.errors.count, "error") %> prohibited this quiz_transaction from being saved:</h2>

      <ul>
        <% quiz_transaction.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quiz_transactions/_quiz_transaction.html.erb
<div id="<%= dom_id quiz_transaction %>">
</div>

app/views/quiz_transactions/edit.html.erb
<h1>Editing quiz transaction</h1>

<%= render "form", quiz_transaction: @quiz_transaction %>

<br>

<div>
  <%= link_to "Show this quiz transaction", @quiz_transaction %> |
  <%= link_to "Back to quiz transactions", quiz_transactions_path %>
</div>

app/views/quiz_transactions/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Quiz transactions</h1>

<div id="quiz_transactions">
  <% @quiz_transactions.each do |quiz_transaction| %>
    <%= render quiz_transaction %>
    <p>
      <%= link_to "Show this quiz transaction", quiz_transaction %>
    </p>
  <% end %>
</div>

<%= link_to "New quiz transaction", new_quiz_transaction_path %>

app/views/quiz_transactions/new.html.erb
<h1>New quiz transaction</h1>

<%= render "form", quiz_transaction: @quiz_transaction %>

<br>

<div>
  <%= link_to "Back to quiz transactions", quiz_transactions_path %>
</div>

app/views/quiz_transactions/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @quiz_transaction %>

<div>
  <%= link_to "Edit this quiz transaction", edit_quiz_transaction_path(@quiz_transaction) %> |
  <%= link_to "Back to quiz transactions", quiz_transactions_path %>

  <%= button_to "Destroy this quiz transaction", @quiz_transaction, method: :delete %>
</div>